//dsl_shadow
// helper para conectarse con server tishadow
var logger = require('./logger.js'), 
	colors = require("colors"),
	connected_socket = null, 
	config = {
		platform : 'ios'
	};

function postToServer(path, data) {
  if (connected_socket==null) {
    connected_socket.socket.reconnect();
    connected_socket.emit(path,data);
    logger.info(path.toUpperCase() + " sent.");
  } else {
    require("./ts_socket").connect(function(socket) {
      connected_socket = socket;
      socket.emit(path,data);
      if (!config.isTailing){
        socket.disconnect();
      }
      logger.info(path.toUpperCase() + " sent.");
    });
  }
}

exports.config = function(keys) {
	for (var i in keys) config[i] = keys[i];
};

exports.send = function(data) {
	postToServer("snippet", {code: data, platform: config.platform});
};

exports.connect = function(onSuccess, onMessage, onError) {
	if (connected_socket==null) {
		var socket = require("./ts_socket").connect(onSuccess, onMessage, onError);
	} else {
		var socket = connected_socket;
	}
    connected_socket = socket;
};

exports.disconnect = function() {
	if (connected_socket!=null) {
		connected_socket.socket.reconnect(false);	// psb: 16-1-2016: this prevents the auto-reconnect after disconnect requested.
		connected_socket.disconnect();
		//console.log("TiShadow Client Disconnected.\n\n".green);
	}
	connected_socket=null;
};

